diff --git a/Makefile.am b/Makefile.am
index 6760e7a..17b6d2b 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1656,7 +1805,7 @@ libviews_plugin_la_LDFLAGS = -avoid-version
 #------------------------
 libwhoami_plugin_la_SOURCES = ldap/servers/plugins/whoami/whoami.c
 
-libwhoami_plugin_la_CPPFLAGS = $(PLUGIN_CPPFLAGS)
+libwhoami_plugin_la_CPPFLAGS = $(DSPLUGIN_CPPFLAGS)
 libwhoami_plugin_la_LIBADD = libslapd.la $(LDAPSDK_LINK) $(NSPR_LINK)
 libwhoami_plugin_la_DEPENDENCIES = libslapd.la
 libwhoami_plugin_la_LDFLAGS = -avoid-version
@@ -1680,6 +1829,7 @@ dbscan_bin_LDADD = $(NSPR_LINK) $(DB_LINK)
 #------------------------
 dsktune_bin_SOURCES = ldap/systools/idsktune.c \
 	ldap/systools/pio.c
+dsktune_bin_CPPFLAGS = $(AM_CPPFLAGS) $(DSPLUGIN_CPPFLAGS)
 
 #------------------------
 # infadd
@@ -1688,7 +1838,7 @@ infadd_bin_SOURCES = ldap/servers/slapd/tools/rsearch/addthread.c \
 	ldap/servers/slapd/tools/rsearch/infadd.c \
 	ldap/servers/slapd/tools/rsearch/nametable.c
 
-infadd_bin_CPPFLAGS = $(AM_CPPFLAGS) @openldap_inc@ @ldapsdk_inc@ @nss_inc@ @nspr_inc@
+infadd_bin_CPPFLAGS = $(AM_CPPFLAGS) $(DSPLUGIN_CPPFLAGS)
 infadd_bin_LDADD = $(NSPR_LINK) $(NSS_LINK) $(LDAPSDK_LINK) $(SASL_LINK) $(LIBSOCKET)
 
 #------------------------
@@ -1698,7 +1848,7 @@ ldap_agent_bin_SOURCES = ldap/servers/snmp/main.c \
 	ldap/servers/snmp/ldap-agent.c \
 	ldap/servers/slapd/agtmmap.c
 
-ldap_agent_bin_CPPFLAGS = $(AM_CPPFLAGS) @netsnmp_inc@ @openldap_inc@ @ldapsdk_inc@ @nss_inc@ @nspr_inc@
+ldap_agent_bin_CPPFLAGS = $(AM_CPPFLAGS) $(DSPLUGIN_CPPFLAGS) @netsnmp_inc@
 ldap_agent_bin_LDADD = $(LDAPSDK_LINK_NOTHR) $(SASL_LINK) $(NSS_LINK) $(NSPR_LINK) $(NETSNMP_LINK) $(THREADLIB)
 if SOLARIS
 ldap_agent_bin_LDADD += -lrt
@@ -1725,7 +1875,7 @@ if SOLARIS
 ldclt_bin_SOURCES += ldap/servers/slapd/tools/ldclt/opCheck.c
 endif
 
-ldclt_bin_CPPFLAGS = $(AM_CPPFLAGS) -I$(srcdir)/ldap/servers/slapd/tools @openldap_inc@ @ldapsdk_inc@ @sasl_inc@ @nss_inc@ @nspr_inc@
+ldclt_bin_CPPFLAGS = $(AM_CPPFLAGS) -I$(srcdir)/ldap/servers/slapd/tools $(DSPLUGIN_CPPFLAGS) $(SASL_INCLUDES)
 ldclt_bin_LDADD = $(NSPR_LINK) $(NSS_LINK) $(LDAPSDK_LINK) $(SASL_LINK) $(LIBNSL) $(LIBSOCKET) $(LIBDL) $(THREADLIB)
 
 #------------------------
@@ -1733,7 +1883,7 @@ ldclt_bin_LDADD = $(NSPR_LINK) $(NSS_LINK) $(LDAPSDK_LINK) $(SASL_LINK) $(LIBNSL
 #------------------------
 ldif_bin_SOURCES = ldap/servers/slapd/tools/ldif.c
 
-ldif_bin_CPPFLAGS = $(AM_CPPFLAGS) @openldap_inc@ @ldapsdk_inc@ @nss_inc@ @nspr_inc@
+ldif_bin_CPPFLAGS = $(AM_CPPFLAGS) $(DSPLUGIN_CPPFLAGS)
 ldif_bin_LDADD = $(NSPR_LINK) $(NSS_LINK) $(LDAPSDK_LINK_NOTHR) $(SASL_LINK)
 
 #------------------------
@@ -1741,7 +1891,7 @@ ldif_bin_LDADD = $(NSPR_LINK) $(NSS_LINK) $(LDAPSDK_LINK_NOTHR) $(SASL_LINK)
 #------------------------
 migratecred_bin_SOURCES = ldap/servers/slapd/tools/migratecred.c
 
-migratecred_bin_CPPFLAGS = $(AM_CPPFLAGS) @openldap_inc@ @ldapsdk_inc@ @nss_inc@ @nspr_inc@
+migratecred_bin_CPPFLAGS = $(AM_CPPFLAGS) $(DSPLUGIN_CPPFLAGS)
 migratecred_bin_LDADD = libslapd.la $(NSPR_LINK) $(NSS_LINK) $(SVRCORE_LINK) $(LDAPSDK_LINK) $(SASL_LINK)
 migratecred_bin_DEPENDENCIES = libslapd.la
 
@@ -1750,7 +1900,7 @@ migratecred_bin_DEPENDENCIES = libslapd.la
 #------------------------
 mmldif_bin_SOURCES = ldap/servers/slapd/tools/mmldif.c
 
-mmldif_bin_CPPFLAGS = $(AM_CPPFLAGS) @openldap_inc@ @ldapsdk_inc@ @nss_inc@ @nspr_inc@
+mmldif_bin_CPPFLAGS = $(AM_CPPFLAGS) $(DSPLUGIN_CPPFLAGS)
 mmldif_bin_LDADD = libslapd.la $(NSPR_LINK) $(NSS_LINK) $(SVRCORE_LINK) $(LDAPSDK_LINK_NOTHR) $(SASL_LINK)
 mmldif_bin_DEPENDENCIES = libslapd.la
 
@@ -1802,11 +1952,10 @@ ns_slapd_SOURCES = ldap/servers/slapd/abandon.c \
 	ldap/servers/slapd/unbind.c \
 	$(GETSOCKETPEER)
 
-ns_slapd_CPPFLAGS = $(AM_CPPFLAGS) @sasl_inc@ @openldap_inc@ @ldapsdk_inc@ @nss_inc@ \
-	@nspr_inc@ @svrcore_inc@ @systemd_inc@
-ns_slapd_LDADD = libslapd.la libldaputil.a $(LDAPSDK_LINK) $(NSS_LINK) $(LIBADD_DL) \
-	$(NSPR_LINK) $(SASL_LINK) $(SVRCORE_LINK) $(LIBNSL) $(LIBSOCKET) $(THREADLIB) $(SYSTEMD_LINK) $(TCMALLOC_LINK)
-ns_slapd_DEPENDENCIES = libslapd.la
+ns_slapd_CPPFLAGS = $(AM_CPPFLAGS) $(DSPLUGIN_CPPFLAGS) $(SASL_INCLUDES) $(SVRCORE_INCLUDES)
+ns_slapd_LDADD = libnunc-stans.la libslapd.la libldaputil.a $(LDAPSDK_LINK) $(NSS_LINK) $(LIBADD_DL) \
+	$(NSPR_LINK) $(SASL_LINK) $(SVRCORE_LINK) $(LIBNSL) $(LIBSOCKET) $(THREADLIB) $(SYSTEMD_LINK) $(EVENT_LINK) $(TCMALLOC_LINK)
+ns_slapd_DEPENDENCIES = libslapd.la libnunc-stans.la
 # We need to link ns-slapd with the C++ compiler on HP-UX since we load
 # some C++ shared libraries (such as icu).
 if HPUX
@@ -1820,7 +1969,7 @@ endif
 #------------------------
 pwdhash_bin_SOURCES = ldap/servers/slapd/tools/pwenc.c
 
-pwdhash_bin_CPPFLAGS = $(AM_CPPFLAGS) @openldap_inc@ @ldapsdk_inc@ @nss_inc@ @nspr_inc@
+pwdhash_bin_CPPFLAGS = $(AM_CPPFLAGS) $(DSPLUGIN_CPPFLAGS)
 pwdhash_bin_LDADD = libslapd.la $(NSPR_LINK) $(NSS_LINK) $(SVRCORE_LINK) $(LDAPSDK_LINK) $(SASL_LINK)
 pwdhash_bin_DEPENDENCIES = libslapd.la
 
@@ -1832,7 +1981,7 @@ rsearch_bin_SOURCES = ldap/servers/slapd/tools/rsearch/nametable.c \
 	ldap/servers/slapd/tools/rsearch/sdattable.c \
 	ldap/servers/slapd/tools/rsearch/searchthread.c
 
-rsearch_bin_CPPFLAGS = $(AM_CPPFLAGS) @openldap_inc@ @ldapsdk_inc@ @nss_inc@ @nspr_inc@
+rsearch_bin_CPPFLAGS = $(AM_CPPFLAGS) $(DSPLUGIN_CPPFLAGS)
 rsearch_bin_LDADD = $(NSPR_LINK) $(NSS_LINK) $(LDAPSDK_LINK) $(SASL_LINK) $(LIBSOCKET)
 
 #-------------------------
@@ -1840,7 +1989,17 @@ rsearch_bin_LDADD = $(NSPR_LINK) $(NSS_LINK) $(LDAPSDK_LINK) $(SASL_LINK) $(LIBS
 #-------------------------
 if WITH_CMOCKA
 
-check_PROGRAMS = test_slapd
+check_PROGRAMS = test_slapd \
+				test_libsds \
+				benchmark_sds \
+				benchmark_par_sds \
+				test_nuncstans \
+				test_nuncstans_stress
+# Mark all check programs for testing
+TESTS = test_slapd \
+		test_libsds \
+		test_nuncstans \
+		test_nuncstans_stress
 
 test_slapd_SOURCES = test/main.c \
 					test/libslapd/test.c \
@@ -1851,8 +2010,43 @@ test_slapd_LDADD = libslapd.la
 test_slapd_LDFLAGS = $(AM_CPPFLAGS) $(CMOCKA_LINKS)
 ### WARNING: Slap.h needs cert.h, which requires the -I/lib/ldaputil!!!
 ### WARNING: Slap.h pulls ssl.h, which requires nss!!!!
-test_slapd_CPPFLAGS = $(AM_CPPFLAGS) @nspr_inc@ @nss_inc@ -I$(srcdir)/include/ldaputil
-
+test_slapd_CPPFLAGS = $(AM_CPPFLAGS) $(DSPLUGIN_CPPFLAGS) $(DSINTERNAL_CPPFLAGS)
+
+test_libsds_SOURCES =  src/libsds/test/test_sds.c \
+						src/libsds/test/test_sds_bpt.c \
+						src/libsds/test/test_sds_cow.c \
+						src/libsds/test/test_sds_set.c \
+						src/libsds/test/test_sds_queue.c \
+						src/libsds/test/test_sds_tqueue.c \
+						src/libsds/test/test_sds_lqueue.c \
+						src/libsds/test/test_fixtures.c
+
+test_libsds_LDFLAGS = $(ASAN_DEFINES) $(PROFILING_LINKS) $(CMOCKA_LINKS)
+test_libsds_LDADD = libsds.la
+test_libsds_CPPFLAGS = $(AM_CPPFLAGS) $(CMOCKA_INCLUDES) $(SDS_CPPFLAGS)
+
+benchmark_sds_SOURCES =  src/libsds/test/benchmark.c \
+						$(libavl_a_SOURCES)
+benchmark_sds_LDFLAGS = $(ASAN_DEFINES) $(PROFILING_LINKS) $(CMOCKA_LINKS)
+benchmark_sds_LDADD = libsds.la
+benchmark_sds_CPPFLAGS = $(AM_CPPFLAGS) $(CMOCKA_INCLUDES) $(SDS_CPPFLAGS) $(DS_INCLUDES)
+
+benchmark_par_sds_SOURCES = src/libsds/test/benchmark_parwrap.c \
+							src/libsds/test/benchmark_par.c \
+							$(libavl_a_SOURCES)
+benchmark_par_sds_LDFLAGS = $(ASAN_DEFINES) $(PROFILING_LINKS) $(CMOCKA_LINKS)
+benchmark_par_sds_LDADD = libsds.la
+benchmark_par_sds_CPPFLAGS = $(AM_CPPFLAGS) $(CMOCKA_INCLUDES) $(SDS_CPPFLAGS) $(DS_INCLUDES)
+
+test_nuncstans_SOURCES = src/nunc-stans/test/test_nuncstans.c
+test_nuncstans_CPPFLAGS = $(AM_CPPFLAGS) $(CMOCKA_INCLUDES) $(NUNCSTANS_CPPFLAGS)
+test_nuncstans_LDADD = libnunc-stans.la libsds.la
+test_nuncstans_LDFLAGS = $(ASAN_DEFINES) $(PROFILING_LINKS) $(CMOCKA_LINKS) $(EVENT_LINK)
+
+test_nuncstans_stress_SOURCES = src/nunc-stans/test/test_nuncstans.c
+test_nuncstans_stress_CPPFLAGS = $(AM_CPPFLAGS) $(CMOCKA_INCLUDES) $(NUNCSTANS_CPPFLAGS)
+test_nuncstans_stress_LDADD = libnunc-stans.la libsds.la
+test_nuncstans_stress_LDFLAGS = $(ASAN_DEFINES) $(PROFILING_LINKS) $(CMOCKA_LINKS) $(EVENT_LINK)
 
 
 endif
@@ -2129,3 +2323,20 @@ srpm: rpmbrprep
 	cd $(RPMBUILD); \
 	rpmbuild --define "_topdir $(RPMBUILD)" \
 	         -bs SPECS/389-ds-base.spec
+
+if HAVE_DOXYGEN
+
+# The rm in man3 is to remove files like: _home_william_development_389ds_libsds_src_.3
+# If there is a way to ignore this in doxygen I'm all ears ...
+
+doxyfile.stamp:
+	cd $(srcdir); $(DOXYGEN) $(abs_top_builddir)/docs/slapi.doxy
+	rm $(abs_top_builddir)/man/man3/_*
+	touch doxyfile.stamp
+
+# Add the docs to make all.
+all-local: doxyfile.stamp
+
+endif
+
+
diff --git a/configure.ac b/configure.ac
index 00e9bc7..0ae54c5 100644
--- a/configure.ac
+++ b/configure.ac
@@ -39,7 +39,7 @@ AC_PROG_LIBTOOL
 AC_HEADER_DIRENT
 AC_HEADER_STDC
 AC_HEADER_SYS_WAIT
-AC_CHECK_HEADERS([arpa/inet.h fcntl.h malloc.h netdb.h netinet/in.h stdlib.h string.h strings.h sys/file.h sys/socket.h sys/time.h unistd.h inttypes.h mntent.h sys/sysinfo.h])
+AC_CHECK_HEADERS([arpa/inet.h errno.h fcntl.h malloc.h netdb.h netinet/in.h stdlib.h string.h strings.h sys/file.h sys/socket.h sys/time.h syslog.h unistd.h inttypes.h mntent.h sys/sysinfo.h])
 
 # Checks for typedefs, structures, and compiler characteristics.
 AC_HEADER_STAT
@@ -112,6 +112,24 @@ AC_ARG_ENABLE(gcc-security, AS_HELP_STRING([--enable-gcc-security], [Enable gcc
 ])
 AC_SUBST([gccsec_defs])
 
+# Pull in profiling.
+AC_MSG_CHECKING(for --enable-profiling)
+AC_ARG_ENABLE(profiling, AS_HELP_STRING([--enable-profiling], [Enable gcov profiling features (default: no)]),
+[
+  AC_MSG_RESULT(yes)
+  profiling_defs="-fprofile-arcs -ftest-coverage -g3 -O0"
+  profiling_links="-lgcov --coverage"
+],
+[
+  AC_MSG_RESULT(no)
+  profiling_defs=""
+  profiling_links=""
+])
+AC_SUBST([profiling_defs])
+AC_SUBST([profiling_links])
+
+
+
 # Used for legacy style packaging where we bundle all of the dependencies.
 AC_MSG_CHECKING(for --enable-bundle)
 AC_ARG_ENABLE(bundle, AS_HELP_STRING([--enable-bundle], [Enable bundled dependencies (default: no)]),
@@ -174,7 +192,7 @@ fi
 AM_CONDITIONAL(enable_ldapi,test "$enable_ldapi" = "yes")
 
 if test -z "$enable_autobind" ; then
-   enable_autobind=no # if not set on cmdline, set default
+   enable_autobind=yes # if not set on cmdline, set default
 fi
 AC_MSG_CHECKING(for --enable-autobind)
 AC_ARG_ENABLE(autobind,
@@ -263,6 +281,9 @@ else
 fi
 AM_CONDITIONAL(enable_posix_winsync,test "$enable_posix_winsync" = "yes")
 
+if test -z "$enable_nunc_stans" ; then
+   enable_nunc_stans=yes # if not set on cmdline, set default
+fi
 AC_MSG_CHECKING(for --enable-nunc-stans)
 AC_ARG_ENABLE(nunc_stans,
         AS_HELP_STRING([--enable-nunc-stans],
@@ -275,6 +296,7 @@ else
 fi
 AM_CONDITIONAL(enable_nunc_stans,test "$enable_nunc_stans" = "yes")
 
+
 # the default prefix - override with --prefix or --with-fhs
 AC_PREFIX_DEFAULT([/opt/$PACKAGE_NAME])
 
@@ -505,6 +527,10 @@ else
   pythonexec='/usr/bin/env python2'
 fi
 
+# Default to no atomic queue operations.
+with_atomic_queue="no"
+with_xsixfour="no"
+
 # we use stty in perl scripts to disable password echo
 # this doesn't work unless the full absolute path of the
 # stty command is used e.g. system("stty -echo") does not
@@ -531,7 +557,12 @@ case $host in
         AC_DEFINE([ATOMIC_64BIT_OPERATIONS], [1], [enabling atomic counter])
         ;;
       x86_64-*-linux*)
-        AC_DEFINE([CPU_x86_64], [], [cpu type x86_64])
+        with_xsixfour="yes"
+        AC_DEFINE([CPU_x86_64], [1], [cpu type x86_64])
+        # This turns on and off LFDS inside of libsds
+        # wibrown -- 2017-02-21 disabled temporarily
+        # with_atomic_queue="yes"
+        # AC_DEFINE([ATOMIC_QUEUE_OPERATIONS], [1], [enabling atomic queue operations])
         AC_DEFINE([ATOMIC_64BIT_OPERATIONS], [1], [enabling atomic counter])
         ;;
       aarch64-*-linux*)
@@ -645,6 +676,7 @@ dnl includes some assembler stuff in counter.o
     ;;
 esac
 
+
 # cmd line overrides default setting above
 if test -n "$with_initddir" ; then
    initdir="$with_initddir"
@@ -669,6 +701,8 @@ if test -z "$initconfigdir" ; then
 fi
 AC_SUBST(initconfigdir)
 
+# Conditionals for makefile.am
+AM_CONDITIONAL([ATOMIC_QUEUE_OPERATIONS], [test "$with_atomic_queue" = "yes"])
 AM_CONDITIONAL([HPUX],[test "$platform" = "hpux"])
 AM_CONDITIONAL([SOLARIS],[test "$platform" = "solaris"])
 AM_CONDITIONAL([FREEBSD],[test "$platform" = "freebsd"])
@@ -686,10 +720,11 @@ m4_include(m4/netsnmp.m4)
 m4_include(m4/kerberos.m4)
 m4_include(m4/pcre.m4)
 m4_include(m4/selinux.m4)
-m4_include(m4/nunc-stans.m4)
 m4_include(m4/systemd.m4)
 m4_include(m4/cmocka.m4)
 m4_include(m4/tcmalloc.m4)
+m4_include(m4/doxygen.m4)
+m4_include(m4/event.m4)
 
 PACKAGE_BASE_VERSION=`echo $PACKAGE_VERSION | awk -F\. '{print $1"."$2}'`
 AC_SUBST(PACKAGE_BASE_VERSION)
@@ -789,6 +824,9 @@ if test "$GCC" != yes ; then
    rm -f libtool.tmp
 fi
 
-AC_CONFIG_FILES([Makefile rpm/389-ds-base.spec])
+# Build our pkgconfig files
+AC_CONFIG_FILES([src/pkgconfig/dirsrv.pc src/pkgconfig/nunc-stans.pc src/pkgconfig/libsds.pc])
+
+AC_CONFIG_FILES([Makefile rpm/389-ds-base.spec  ])
 
 AC_OUTPUT
diff --git a/ldap/servers/slapd/slap.h b/ldap/servers/slapd/slap.h
index f1233b4..5871bf0 100644
--- a/ldap/servers/slapd/slap.h
+++ b/ldap/servers/slapd/slap.h
@@ -124,7 +124,7 @@ typedef struct symbol_t {
 #include <pwd.h>
 
 #ifdef ENABLE_NUNC_STANS
-#include <nunc-stans/nunc-stans.h>
+#include <nunc-stans.h>
 #endif
 
 #ifdef WITH_SYSTEMD
diff --git a/rpm/389-ds-base.spec.in b/rpm/389-ds-base.spec.in
index ea7ff31..cde46fd 100644
--- a/rpm/389-ds-base.spec.in
+++ b/rpm/389-ds-base.spec.in
@@ -19,9 +19,6 @@
 # nunc-stans only builds on x86_64 for now
 # To build without nunc-stans, set use_nunc_stans to 0.
 %global use_nunc_stans __NUNC_STANS_ON__
-%if %{use_nunc_stans}
-%global nunc_stans_ver 0.2.1
-%endif
 
 # This enables an ASAN build. This should not go to production, so we rename.
 %global use_asan __ASAN_ON__
@@ -46,14 +43,15 @@ Release:          __RELEASE__%{?dist}
 License:          GPLv3+
 URL:              http://www.port389.org/
 Group:            System Environment/Daemons
+# Is this still needed?
 BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 Obsoletes:        %{name}-selinux
 Conflicts:        selinux-policy-base < 3.9.8
 # upgrade path from monolithic %{name} (including -libs & -devel) to %{name} + %{name}-snmp
 Obsoletes:        %{name} <= 1.3.5.4
-Requires:         %{name}-libs = %{version}-%{release}
-Provides:         ldif2ldbm 
+Provides:         ldif2ldbm
 
+# Attach the buildrequires to the top level package:
 BuildRequires:    nspr-devel
 BuildRequires:    nss-devel
 BuildRequires:    svrcore-devel >= 4.1.2
@@ -92,18 +90,30 @@ BuildRequires:    libasan
 BuildRequires:    autoconf
 BuildRequires:    automake
 BuildRequires:    libtool
+# For our documentation
+BuildRequires:    doxygen
+# For tests!
+BuildRequires:    libcmocka-devel
+%if %{use_nunc_stans}
+BuildRequires:    libevent-devel
+%endif
 
 %if %{use_tcmalloc}
 BuildRequires:    gperftools-devel
-Requires:         gperftools-libs
 %endif
+# END BUILD REQUIRES
 
+# Now, attach the requires only to the package that needs them.
+# -libs has most of our runtime libs
+Requires:         %{name}-libs = %{version}-%{release}
+# Attach to -base our script deps
+%if %{use_tcmalloc}
+Requires:         gperftools-libs
+%endif
 # this is needed for using semanage from our setup scripts
 Requires:         policycoreutils-python
-
 # This is needed for our future move to python selinux interaction.
 Requires:         libsemanage-python
-
 # the following are needed for some of our scripts
 %if %{use_openldap}
 Requires:         openldap-clients
@@ -112,61 +122,46 @@ Requires:         mozldap-tools
 %endif
 # use_openldap assumes perl-Mozilla-LDAP is built with openldap support
 Requires:         perl-Mozilla-LDAP
-
 # this is needed to setup SSL if you are not using the
 # administration server package
 Requires:         nss-tools
-
 # these are not found by the auto-dependency method
 # they are required to support the mandatory LDAP SASL mechs
 Requires:         cyrus-sasl-gssapi
 Requires:         cyrus-sasl-md5
 # This is optionally supported by us, as we use it in our tests
 Requires:         cyrus-sasl-plain
-
-# this is needed for verify-db.pl
+# this is needed for verify-db.pl and backldbm
 %if %{use_db4}
+Requires:         db4
 Requires:         db4-utils
 %else
 Requires:         libdb-utils
+Requires:         libdb
 %endif
-
 # This picks up libperl.so as a Requires, so we add this versioned one
 Requires:         perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
-
 # Needed by logconv.pl
 Requires:         perl-DB_File
 Requires:         perl-Archive-Tar
-
 # for the init script
 Requires(post):   systemd-units
 Requires(preun):  systemd-units
 Requires(postun): systemd-units
-
 # for setup-ds.pl
 Requires:         bind-utils
-
-# for setup-ds.pl to support ipv6 
+# for setup-ds.pl to support ipv6
 %if %{use_Socket6}
 Requires:         perl-Socket6
 %else
 Requires:         perl-Socket
 %endif
 Requires:         perl-NetAddr-IP
-Requires:         systemd-libs
-
-%if %{use_asan}
-Requires:    libasan
-Requires:    llvm
-%endif
 
 Source0:          http://www.port389.org/sources/%{name}-%{version}%{?prerel}.tar.bz2
 # 389-ds-git.sh should be used to generate the source tarball from git
 Source1:          %{name}-git.sh
 Source2:          %{name}-devel.README
-%if %{use_nunc_stans}
-Source3:          https://git.fedorahosted.org/cgit/nunc-stans.git/snapshot/nunc-stans-%{nunc_stans_ver}.tar.xz
-%endif
 
 %description
 389 Directory Server is an LDAPv3 compliant server.  The base package includes
@@ -177,37 +172,41 @@ isn't what you want. Please contact support immediately.
 Please see http://seclists.org/oss-sec/2016/q1/363 for more information.
 %endif
 
+
+
 %package          libs
 Summary:          Core libraries for 389 Directory Server (%{variant})
 Group:            System Environment/Daemons
-BuildRequires:    nspr-devel
-BuildRequires:    nss-devel
-BuildRequires:    svrcore-devel
+# You can work this out by running LDD on libslapd.so to see what it needs in
+# isolation.
+Requires:         nss
+Requires:         nspr
 %if %{use_openldap}
-BuildRequires:    openldap-devel
-%else
-BuildRequires:    mozldap-devel
-%endif
-%if %{use_db4}
-BuildRequires:    db4-devel
+Requires:         openldap
 %else
-BuildRequires:    libdb-devel
+# What does mozldap need?
+Requires:         mozldap-tools
 %endif
-BuildRequires:    cyrus-sasl-devel
-BuildRequires:    libicu-devel
-BuildRequires:    pcre-devel
+
 %if %{use_nunc_stans}
-BuildRequires:    libtalloc-devel
-BuildRequires:    libevent-devel
-BuildRequires:    libtevent-devel
+Requires:         libevent
+%endif
+Requires:         systemd-libs
+# Pull in sasl
+Requires:         cyrus-sasl-lib
+# KRB
+Requires:         krb5-libs
+%if %{use_asan}
+Requires:    libasan
+Requires:    llvm
 %endif
-BuildRequires:    systemd-devel
 
 %description      libs
 Core libraries for the 389 Directory Server base package.  These libraries
 are used by the main package and the -devel package.  This allows the -devel
 package to be installed with just the -libs package and without the main package.
 
+
 %package          devel
 Summary:          Development libraries for 389 Directory Server (%{variant})
 Group:            Development/Libraries
@@ -221,16 +220,14 @@ Requires:         openldap-devel
 %else
 Requires:         mozldap-devel
 %endif
-%if %{use_nunc_stans}
-Requires:         libtalloc
-Requires:         libevent
-Requires:         libtevent
-%endif
+# systemd-libs contains the headers iirc.
 Requires:         systemd-libs
 
 %description      devel
 Development Libraries and headers for the 389 Directory Server base package.
 
+
+
 %package          snmp
 Summary:          SNMP Agent for 389 Directory Server
 Group:            System Environment/Daemons
@@ -241,6 +238,9 @@ Obsoletes:        %{name} <= 1.3.5.4
 %description      snmp
 SNMP Agent for the 389 Directory Server base package.
 
+
+
+
 %package -n python2-%{srcname}-tests
 Summary:          The lib389 Continuous Integration Tests
 Group:            Development/Libraries
@@ -257,6 +257,8 @@ BuildRequires: python2-setuptools
 %description  -n  python2-%{srcname}-tests
 The lib389 CI tests that can be run against the Directory Server.
 
+
+
 # Can't build on EL7! Python3 tooling is too broken :(
 # We have to use >= 8, because <= 7 doesn't work ....
 %if 0%{?rhel} >= 8 || 0%{?fedora}
@@ -272,32 +274,16 @@ BuildRequires:    python%{python3_pkgversion}-setuptools
 The lib389 CI tests that can be run against the Directory Server.
 %endif
 
+
+
+
 %prep
 %setup -q -n %{name}-%{version}%{?prerel}
 
-%if %{use_nunc_stans}
-%setup -q -n %{name}-%{version}%{?prerel} -T -D -b 3
-%endif
 cp %{SOURCE2} README.devel
 
 %build
 
-%if %{use_nunc_stans}
-pushd ../nunc-stans-%{nunc_stans_ver}
-autoreconf -fiv
-%configure --with-fhs --libdir=%{_libdir}/%{pkgname}
-# We install into our build dir first, then later we install to the correct build root.
-# This is to make it possible for directory server to use us, else we can't resolve
-# liblfds during link time.
-# Frankly, this is horrible, but until we can make nunc-stans a package, it'll
-# have to do... :(
-# Can't use SMP flags here
-make DESTDIR=`pwd` install
-# Remove these else it breaks libtool
-rm ./%{_libdir}/%{pkgname}/*.{a,la}
-popd
-%endif
-
 %if %{use_openldap}
 OPENLDAP_FLAG="--with-openldap"
 %endif
@@ -306,7 +292,7 @@ OPENLDAP_FLAG="--with-openldap"
 NSSARGS="--with-svrcore-inc=%{_includedir} --with-svrcore-lib=%{_libdir} --with-nss-lib=%{_libdir} --with-nss-inc=%{_includedir}/nss3"
 
 %if %{use_nunc_stans}
-NUNC_STANS_FLAGS="--enable-nunc-stans --with-nunc-stans=../nunc-stans-%{nunc_stans_ver}/usr --with-nunc-stans-inc=../nunc-stans-%{nunc_stans_ver}/%{_includedir} --with-nunc-stans-lib=../nunc-stans-%{nunc_stans_ver}/%{_libdir}/%{pkgname}"
+NUNC_STANS_FLAGS="--enable-nunc-stans"
 %endif
 
 %if %{use_asan}
@@ -324,7 +310,8 @@ autoreconf -fiv
            --with-systemdsystemunitdir=%{_unitdir} \
            --with-systemdsystemconfdir=%{_sysconfdir}/systemd/system \
            --with-systemdgroupname=%{groupname} $NSSARGS $NUNC_STANS_FLAGS \
-           --with-systemd $TCMALLOC_FLAGS $ASAN_FLAGS
+           --with-systemd $TCMALLOC_FLAGS $ASAN_FLAGS \
+           --enable-cmocka
 
 # Generate symbolic info for debuggers
 export XCFLAGS=$RPM_OPT_FLAGS
@@ -347,14 +334,10 @@ make setup.py
 %install
 rm -rf $RPM_BUILD_ROOT
 
-%if %{use_nunc_stans}
-pushd ../nunc-stans-%{nunc_stans_ver}
-# This is the *actual* install of nunc-stans.
 make DESTDIR="$RPM_BUILD_ROOT" install
-popd
-%endif
 
-make DESTDIR="$RPM_BUILD_ROOT" install
+# Copy in our docs from doxygen.
+cp -r %{_builddir}/%{name}-%{version}/man/man3 $RPM_BUILD_ROOT/%{_mandir}/man3
 
 %if 0%{?rhel} >= 8 || 0%{?fedora}
 %py2_install
@@ -379,6 +362,9 @@ rm -f $RPM_BUILD_ROOT%{_libdir}/%{pkgname}/plugins/*.la
 # make sure perl scripts have a proper shebang 
 sed -i -e 's|#{{PERL-EXEC}}|#!/usr/bin/perl|' $RPM_BUILD_ROOT%{_datadir}/%{pkgname}/script-templates/template-*.pl
 
+%check
+make DESTDIR="$RPM_BUILD_ROOT" check
+
 %clean
 rm -rf $RPM_BUILD_ROOT
 
@@ -508,15 +494,6 @@ fi
 %{_mandir}/man8/*
 %exclude %{_sbindir}/ldap-agent*
 %exclude %{_mandir}/man1/ldap-agent.1.gz
-# Don't rm these files, just exclude them!
-%exclude %{_datadir}/doc/nunc-stans/*
-%exclude %{_libdir}/%{pkgname}/pkgconfig/nunc-stans.pc
-%exclude %{_includedir}/nunc-stans/nunc-stans.h
-%exclude %{_mandir}/man3/md_docs_job-safety.3.gz
-%exclude %{_mandir}/man3/md_docs_intro.3.gz
-%exclude %{_mandir}/man3/ns_job_t.3.gz
-%exclude %{_mandir}/man3/ns_thrpool_config.3.gz
-%exclude %{_mandir}/man3/nunc-stans.h.3.gz
 %exclude %{_unitdir}/%{pkgname}-snmp.service
 
 %files devel
@@ -525,9 +502,10 @@ fi
 %{_includedir}/%{pkgname}
 %{_libdir}/%{pkgname}/libslapd.so
 %{_libdir}/%{pkgname}/libns-dshttpd.so
+%{_mandir}/man3/*
 %if %{use_nunc_stans}
 %{_libdir}/%{pkgname}/libnunc-stans.so
-%{_libdir}/%{pkgname}/liblfds710.so
+%{_libdir}/%{pkgname}/libsds.so
 %endif
 %{_libdir}/pkgconfig/*
 
@@ -536,10 +514,10 @@ fi
 %doc LICENSE LICENSE.GPLv3+ LICENSE.openssl README.devel
 %dir %{_libdir}/%{pkgname}
 %{_libdir}/%{pkgname}/libslapd.so.*
-%{_libdir}/%{pkgname}/libns-dshttpd.so.*
+%{_libdir}/%{pkgname}/libns-dshttpd-*.so
 %if %{use_nunc_stans}
 %{_libdir}/%{pkgname}/libnunc-stans.so.*
-%{_libdir}/%{pkgname}/liblfds710.so.*
+%{_libdir}/%{pkgname}/libsds.so.*
 %endif
 
 %files snmp
